Loading...
Searching...
No Matches
Sip_call_id

## Data Structures

struct | sip_call_id_s
| Structure for Call-ID (and In-Reply-To) header fields. More...

## Macros

#define | sip_call_id(sip)
| Access a SIP Call-ID header structure sip_call_id_t from sip_t.
#define | SIP_CALL_ID_INIT()
| Initializer for structure sip_call_id_t.
#define | SIPTAG_CALL_ID(x)
| Tag list item for pointer to a Call-ID header structure sip_call_id_t.
#define | SIPTAG_CALL_ID_REF(x)
| Tag list item for reference to a Call-ID header pointer.
#define | SIPTAG_CALL_ID_STR(s)
| Tag list item for string with Call-ID header value.
#define | SIPTAG_CALL_ID_STR_REF(x)
| Tag list item for reference to a Call-ID header string.

## Typedefs

typedef struct sip_call_id_s | sip_call_id_t
| @

## Functions

issize_t | sip_call_id_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Call-ID header.
issize_t | sip_call_id_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Call-ID header.
sip_call_id_t * | sip_call_id_init (sip_call_id_t x[1])
| Initialize a structure sip_call_id_t.
int | sip_is_call_id (sip_header_t const *header)
| Test if header object is instance of sip_call_id_t.
sip_call_id_t * | sip_call_id_dup (su_home_t *home, sip_call_id_t const *hdr))
| Duplicate a list of Call-ID header header structures sip_call_id_t.
sip_call_id_t * | sip_call_id_copy (su_home_t *home, sip_call_id_t const *hdr))
| Copy a list of Call-ID header header structures sip_call_id_t.
sip_call_id_t * | sip_call_id_make (su_home_t *home, char const *s))
| Make a Call-ID header structure sip_call_id_t.
sip_call_id_t * | sip_call_id_format (su_home_t *home, char const *fmt,...)))
| Make a Call-ID header from formatting result.
sip_call_id_t * | sip_call_id_create (su_home_t *home, char const *domain)
| Create a Call-ID header object.

## Variables

msg_hclass_t | sip_call_id_class []
| Header class for Call-ID header.
tag_typedef_t | siptag_call_id
| Tag for Call-ID header object.
tag_typedef_t | siptag_call_id_str
| Tag for string with Call-ID header value.

## Detailed Description

## Macro Definition Documentation

## SIP_CALL_ID_INIT

#define SIP_CALL_ID_INIT | ( |  | ) |

Initializer for structure sip_call_id_t.

A static sip_call_id_t structure for Call-ID header must be initialized with the SIP_CALL_ID_INIT() macro. For instance,

sip_call_id_t sip_call_id = SIP_CALL_ID_INIT;
sip_call_id_t
struct sip_call_id_s sip_call_id_t
@
Definition sip.h:145
sip_call_id
#define sip_call_id(sip)
Access a SIP Call-ID header structure sip_call_id_t from sip_t.
Definition sip_protos.h:2273
SIP_CALL_ID_INIT
#define SIP_CALL_ID_INIT()
Initializer for structure sip_call_id_t.
Definition sip_protos.h:2290

## SIPTAG_CALL_ID

#define SIPTAG_CALL_ID | ( |  | x | ) |

Tag list item for pointer to a Call-ID header structure sip_call_id_t.

The SIPTAG_CALL_ID() macro is used to include a tag item with a pointer to a sip_call_id_t structure in a tag list.

Parameters

  x | pointer to a sip_call_id_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_CALL_ID_REF().

## SIPTAG_CALL_ID_STR

#define SIPTAG_CALL_ID_STR | ( |  | s | ) |

Tag list item for string with Call-ID header value.

The SIPTAG_CALL_ID_STR() macro is used to include a tag item with a string containing value of a sip_call_id_t header in a tag list.

Parameters

  s | pointer to a string containing Call-ID header value, or NULL.

The string in SIPTAG_CALL_ID_STR() can be converted to a sip_call_id_t header structure by giving the string s has second argument to function sip_call_id_make().

The corresponding tag taking reference parameter is SIPTAG_CALL_ID_STR_REF().

## Typedef Documentation

## sip_call_id_t

typedef struct sip_call_id_s sip_call_id_t

@

The Call-ID header uniquely identifies a particular invitation or all registrations of a particular client. It is defined in RFC 3261 as follows:

Call-ID = ( "Call-ID" / "i" ) HCOLON callid
callid = word [ "@" word ]
word = 1*(alphanum / "-" / "." / "!" / "%" / "*" /
"_" / "+" / "`" / "'" / "~" / "(" / ")" / "<" / ">" /
":" / "\" / DQUOTE / "/" / "[" / "]" / "?" / "{" / "}" )

The parsed Call-ID Header is stored in sip_call_id_t structure.

The structure sip_call_id_t contains representation of SIP Call-ID header.

The sip_call_id_t is defined as follows:

typedef struct sip_call_id_s {
sip_common_t i_common[1]; // Common fragment info
sip_call_id_t *i_next; // Link to next (dummy)
char const *i_id; // ID value
uint32_t i_hash; // Hash value (always nonzero)
} sip_call_id_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_call_id_s
Structure for Call-ID (and In-Reply-To) header fields.
Definition sip.h:438
sip_call_id_s::i_id
char const * i_id
ID value.
Definition sip.h:441
sip_call_id_s::i_next
sip_call_id_t * i_next
Link to next (In-Reply-To).
Definition sip.h:440
sip_call_id_s::i_hash
uint32_t i_hash
Hash value (always nonzero).
Definition sip.h:442
sip_call_id_s::i_common
sip_common_t i_common[1]
Common fragment info.
Definition sip.h:439
uint32_t
SU_U32_T uint32_t

## Function Documentation

## sip_call_id_copy()

sip_call_id_t * sip_call_id_copy | ( | su_home_t * | home,
|  | sip_call_id_t const * | hdr )

inline

Copy a list of Call-ID header header structures sip_call_id_t.

The function sip_call_id_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  call_id = sip_call_id_copy(home, sip->sip_call_id);
  sip_call_id_copy
  sip_call_id_t * sip_call_id_copy(su_home_t *home, sip_call_id_t const *hdr))
  Copy a list of Call-ID header header structures sip_call_id_t.
  Definition sip_protos.h:2420

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_call_id_create()

sip_call_id_t * sip_call_id_create | ( | su_home_t * | home,
|  | char const * | domain )

Create a Call-ID header object.

Create a Call-ID header object with a new unique value. It uses su_guid_generate() function to generate the value. If the local host name domain is specified, it is prepended to the generated value instead of local MAC address.

Parameters

  home | memory home
  domain | local domain name

Returns
  A pointer to newly created Call-ID header object when successful or NULL upon an error.

See also
  su_guid_generate(), su_guid_sprintf()

## sip_call_id_dup()

sip_call_id_t * sip_call_id_dup | ( | su_home_t * | home,
|  | sip_call_id_t const * | hdr )

inline

Duplicate a list of Call-ID header header structures sip_call_id_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  call_id = sip_call_id_dup(home, sip->sip_call_id);
  sip_call_id_dup
  sip_call_id_t * sip_call_id_dup(su_home_t *home, sip_call_id_t const *hdr))
  Duplicate a list of Call-ID header header structures sip_call_id_t.
  Definition sip_protos.h:2377

Returns
  A pointer to the newly duplicated sip_call_id_t header structure, or NULL upon an error.

## sip_call_id_format()

sip_call_id_t * sip_call_id_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Call-ID header from formatting result.

Make a new sip_call_id_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_call_id_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_call_id_init()

sip_call_id_t * sip_call_id_init | ( | sip_call_id_t | x[1] | ) |

inline

Initialize a structure sip_call_id_t.

An sip_call_id_t structure for Call-ID header can be initialized with the sip_call_id_init() function/macro. For instance,

sip_call_id_t sip_call_id;
sip_call_id_init(&sip_call_id);
sip_call_id_init
sip_call_id_t * sip_call_id_init(sip_call_id_t x[1])
Initialize a structure sip_call_id_t.
Definition sip_protos.h:2308

## sip_call_id_make()

sip_call_id_t * sip_call_id_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Call-ID header structure sip_call_id_t.

The function sip_call_id_make() makes a new sip_call_id_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_call_id_t header structure, or NULL upon an error.

## sip_is_call_id()

int sip_is_call_id | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_call_id_t.

Check if the header class is an instance of Call-ID header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header call_id
  0 | (false) otherwise

## Variable Documentation

## sip_call_id_class

msg_hclass_t sip_call_id_class[]

extern

Header class for Call-ID header.

The header class sip_call_id_class defines how a SIP Call-ID header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_call_id_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.